dt=1;
tk=10000;
n=ceil(tk/dt);
t=zeros(1,n);

T=zeros(1,n);  % temperatura smesi v reaktore
Tt=zeros(1,n); % temperatura smesi teplonositela
Ca=zeros(1,n);
Cb=zeros(1,n);
Cc=zeros(1,n);
N=zeros(1,n);
Xpn=zeros(1,n);
en=zeros(1,n);
Tvx=zeros(1,n);
a1=0;
a2=0;

Kp=100;       %Nastroyki regulyatora
Ti=50000000;
sum=0;
del=0;     % zona nechyvctvitelnocti
Td=10;    %inercionnoct' datchica

A=30;        % mnozhitel
E=40000;     % energia aktivacii
R=8.31;      % gasovaya const
K=1000;      % koef teploprovodnosti
Diam=1.5;    % diametr rubashki
diam=1.4;    % diametr reaktora
Vis=1.615;    % visota reaktora
dh=22500;% teplovoi effekt reaksii


cp1=2000;    % teploemkost smesi v reaktore
Ro1=1500;    % plotnost smesi v reaktore
cp2=4100;    % teploemkost teplonositelya
Ro2=1000;    %plotnost teplonositelya v rubashke
s=3.14*diam*Vis;         % ploshad bokovoj poverhnosti reaktora
v1=3.14*Vis*diam^2/4;    % ob`em reaktora
v2=3.14*Vis*Diam^2/4-v1; % ob'em rubashki

      % NOMINALNIY STATICHESKIY REZHIM("*1.05" - vozmushenie)
Cavx=100;       % konzentraziya komponenta "A" na vxode v reaktor
Cbvx=30;        % konzentraziya komponenta "B" na vxode v reaktor
Tt1=90;         % temperatura teplonositelya 1 na vhode v rubashku
Tt2=15;         % temperatura teplonositelya 2 na vhode v rubashku
Pa=101325;      % davlenie v rubashke 
Pt=230000;      % davlenie pered klapanom
       % Nachalnie uslovia
Ca(1,1)=Cavx;       % konzentraziya komponenta "A" v reaktore 
Cb(1,1)=Cbvx;      % konzentraziya komponenta "B" v reaktore  
Cc(1,1)=0;        % konzentraziya komponenta "C" v reaktore
T(1,1)=15;           % temperatura smesi v reaktore
Tt(1,1)=15;          % temperatura teplonositelya v rubashke
Tizm(1,1)=15;

tau1=3000;
tau2=7000;
tau3=10000;


for i=1:tau1/dt
       Tvx(i)=15+0.0083*i;
    end
    
   for i=tau1:tau2/dt
      Tvx(i)=40;
   end
   for i=tau2:tau3/dt
      Tvx(i)=-0.0033*i+63.333;
   end
   for i=(tau3/dt+1):n
      Tvx(i)=30;
   end
   
                     % DINAMIC
                     for i=2:n
                        
                        
                        if i*dt >tau2
              a1=0;
              a2=1;
              kv1=0;
              kv2=10;
           else a1=1;
              a2=0;
              kv1=5;
              kv2=0;
              end

if a2==1
   e=(Tizm(1,i-1)-Tvx(1,i-1))/180*100;
   else
      e=-(Tizm(1,i-1)-Tvx(1,i-1))/180*100;
      end
en(1,i-1)=e;
            
 if abs(e)<del/2
    e=0;
 else e=(abs(e)-del/2)*sign(e);
 end
 Xp=Kp*e+sum*dt/Ti*Kp;
 if Xp<0 Xp=0;
 end
    if Xp>100 Xp=100;
    end
       Xpn(1,i)=Xp;
 N(1,i)=A*exp(-E/(R*(T(1,i-1)+273)))*Ca(1,i-1)*Cb(1,i-1);   % skorost reakcii
                                
                 % pokomponentniy materialniy balans dlya reaktora  
         Ca(1,i)=-N(1,i)*dt+Ca(1,i-1); 
         Cb(1,i)=-N(1,i)*dt+Cb(1,i-1);
         Cc(1,i)=N(1,i)*dt+Cc(1,i-1);
                 % materialniy balans dlya rubashki
         Gt=0.1*(kv1+kv2)*Xp/100*((Pt-Pa)/Ro2)^0.5/3600; 
                  % teplovoy balans (T-reaktor, Tt-rubashka)

T(1,i)=(K*s*(Tt(1,i-1)-T(1,i-1))+dh*N(1,i)*v1)*dt/(Ro1*v1*cp1)+T(1,i-1);
Tt(1,i)=Tt(1,i-1)+dt*(Gt*Ro2*cp2*(a1*(Tt1-Tt(1,i-1))+a2*(Tt2-Tt(1,i-1)))-K*s*(Tt(1,i-1)-T(1,i-1)))/(Ro2*v2*cp2);
                  % yravnenie datchica
                  Tizm(1,i)=(T(1,i-1)-Tizm(1,i-1))*dt/Td+Tizm(1,i-1);
                  t(i)=i*dt;
sum=sum+e;
end

figure(1)
%plot(t,Ca,'r');
%hold on;
%plot(t,Cb,'m');
%hold on;
%plot(t,Cc,'b');
%hold on;
plot(t,T,'r');
hold on;
plot(t,Tvx,'k');
hold on;
plot(t,Tt,'g');
hold on;
plot(t,en,'b');
hold on;
plot(t,Tizm,'m');
hold on
figure(2)
plot(t,Xpn,'m');

